package de.ivu.elect.presentation.stimmzettel.action;

import javax.annotation.Nullable;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.stimmzettel.boundary.StimmzettelEdit;
import de.ivu.elect.business.stimmzettel.entity.Stimmzettel;
import de.ivu.elect.business.stimmzettel.entity.StimmzettelMeta;
import de.ivu.elect.jee.faces.FacesContextUtil;
import de.ivu.elect.jee.faces.FacesMessageUtil;
import de.ivu.elect.jee.presentation.redirect.Redirect;

/**
 * NICHT ALS VORLAGE VERWENDEN(!)
 */
@Named(StimmzettelDeleteAction.COMPONENT_NAME)
public class StimmzettelDeleteAction extends AbstractStimmzettelAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "stimmzettelDeleteAction";

  @Inject
  private transient StimmzettelEdit stimmzettelEdit;

  @Inject
  private transient StimmzettelMeta stimmzettelMeta;

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.STIMMZETTEL_DELETE;
  }

  @Override
  public boolean isFireChangeEvent() {
    return true;
  }

  @Override
  @Nullable
  protected String doIt(Stimmzettel stimmzettel) {
    conversationSelect.setEntity(stimmzettel);
    return null;
  }

  @Override
  public String getDialogName() {
    return "DeleteConfirm";
  }

  @Override
  public String getLabelKey() {
    return "entity.edit.action.delete";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconDelete();
  }

  public Stimmzettel getStimmzettel() {
    return conversationSelect.getEntity();
  }

  @Redirect
  public String delete() {
    stimmzettelEdit.delete(getStimmzettel());
    FacesMessageUtil.addInfoMessage("entity.edit.action.delete.success.message",
        "entity.edit.action.delete.success.message", stimmzettelMeta.getEinzahlMessage());
    return FacesContextUtil.getCurrentViewId();
  }
}
